/****************************************************************************
 *   Copyright (C) 2004 by Jurij Ivastsuk-Kienbaum                          *
 *   jurij@device-image.de                                                  *
 *                                                                          *
 *   This program is free software; you can redistribute it and/or modify   *
 *   it under the terms of the GNU General Public License as published by   *
 *   the Free Software Foundation; either version 2 of the License,         *
 *   or (at your option) any later version.                                 *
 *   This program is distributed in the hope that it will be useful,        *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty            *
 *   of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                *
 *   See the GNU General Public License for more details.                   *
 *   You should have received a copy of the GNU General Public License      *
 *   along with this program; if not, write to the Free Software Foundation,*
 *   Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA            *
 ***************************************************************************/
#include "common_tools.h"

using namespace std;

struct tm *myTime;
time_t TimeNow = time(NULL);



string cut_path(string path)
 {
 	string file;
 	string res = "";
	int pos;
	file = path;
	pos = file.find_last_of(DIR_CHAR);
	if(pos != -1)
	{
		res = file.substr(pos+1);
	}
	else
	{
        	res = file;
	}

  return res;
 }


string add_last_slash(string path)
 {
 	unsigned int i;
	string res = "";
	string tmp_path;

	tmp_path = path;
	i = tmp_path.find_last_of(DIR_CHAR);

	if(i+1 == tmp_path.length())
	{

		res = tmp_path;
	}
	else
	{
 		tmp_path.append(DIR_CHAR);
		res = tmp_path;
	}
  return res;
 }


string get_path(string path)
{
 string pathstr;
 int pos;



	pathstr = path;
	pos = pathstr.find_last_of(DIR_CHAR);
	if(pos != -1)
	{
		pathstr = pathstr.substr(0, pos+1);
	}
	else
	{
        	pathstr = "";
	}

 return pathstr;
}


string make_ofname(string init_name, int indx)
{
 string fname, tmp_name;
 string suffix;
 string prefix;
 string counter;
 ostringstream i_str;

 int pos;

 suffix.assign(".spl.zp");
 prefix.assign("_");
 i_str << indx;
 counter.assign(i_str.str());
 i_str.str("");

 pos = init_name.find_last_of(".");
 if(pos == -1)
 {
 	tmp_name = init_name;
 }
 else
 {
 	tmp_name = init_name.substr(0, pos);
 }

 fname = tmp_name + prefix + counter + suffix;

 return fname;
}


string get_def_filename()
{
  string time;
  int pos;
	time.assign(asctime(localtime(&TimeNow)));
	pos = time.find(" ");
	while(pos != -1)
	{
                time.replace(pos, 1, "_");
		pos = time.find(" ", pos+1);
	}
	pos = time.find(":");
	while(pos != -1)
	{
                time.replace(pos, 1, "_");
		pos = time.find(":", pos+1);
	}

	time = time.erase(time.length()-1);
 return time;
}

void log(string log_line)
{
  filebuf buffer;
  iostream stream(&buffer);
  time_t CurrTime = time(NULL);
  ostringstream t_st;
  struct tm mytime;
  ostringstream mon, day, hour, min, sec;

   mytime = *localtime(&CurrTime);


   if(mytime.tm_mon +1 < 10)
   {
   	mon << "0" << (mytime.tm_mon +1);
   }
   else
   {
   	mon << (mytime.tm_mon +1);
   }

   if(mytime.tm_mday < 10)
   {
   	day << "0" << mytime.tm_mday;
   }
   else
   {
   	day << mytime.tm_mday;
   }

   if(mytime.tm_hour < 10)
   {
   	hour << "0" << mytime.tm_hour;
   }
   else
   {
   	hour << mytime.tm_hour;
   }

   if(mytime.tm_min < 10)
   {
   	min << "0" << mytime.tm_min;
   }
   else
   {
   	min << mytime.tm_min;
   }

   if(mytime.tm_sec < 10)
   {
   	sec << "0" << mytime.tm_sec;
   }
   else
   {
   	sec << mytime.tm_sec;
   }

  buffer.open("debug.log", ios::out | ios::app);


  t_st << day.str() << "-" << mon.str() << "-" << (mytime.tm_year+1900) << " " << hour.str() << ":" << min.str() << ":" << sec.str();

  stream << t_st.str() << " " << log_line.c_str() << '\n';

  buffer.close();
}


void do_exit(int exit_code)
 {

        exit(exit_code);
 }



string elaps_time(unsigned long time_sec)
{
	string ret_time;
	ostringstream elt_st;
	ostringstream hour, min, sec;

	int hr = 0;
	int mn = 0;
	int sc = 0;

	if(time_sec > 3599)
	{
		hr = time_sec/3600;

		sc = time_sec - (hr*3600);


		if(sc > 59)
		{
			mn = sc/60;
			sc = time_sec - (hr*3600) - (mn*60);
		}
		else
		{
			mn = 0;
		}
	}

	else if (time_sec > 59)
	{
		mn = time_sec/60;
		sc = time_sec - (mn*60);
	}
	else
	{
		sc = time_sec;
	}


	if( hr < 10)
	{
		hour << "0" << hr;
	}
	else
	{
		hour << hr;
	}

	if( mn < 10)
	{
		min << "0" << mn;
	}
	else
	{
		min << mn;
	}

	if( sc < 10)
	{
		sec << "0" << sc;
	}
	else
	{
		sec << sc;
	}

	elt_st << hour.str() << "hr" << ":" << min.str() << "min" << ":" << sec.str() << "sec";

	ret_time = elt_st.str();
   return ret_time;
}

